View Issue Details

IDProjectCategoryView StatusLast Update
0037781LazarusIDEpublic2021-01-19 16:37
ReporterCyrax Assigned ToJuha Manninen  
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
PlatformLinux x86_64OSArch 
Product Version2.1 (SVN) 
Summary0037781: Lazarus crashes with SIGABRT when opening a certain projects.
DescriptionLike in summary, Lazarus IDE crashes with SIGABRT when opening a certain projects.
Additional InformationFPC trunk 3.3.1 r46902 x86_64-linux.

FPC is built with these options :
          -gw2 
          -godwarfsets 
          -godwarfmethodclassprefix
          -gl
          -O-
          -Xs-
          -Si-
          -vbq
          -Sew-
          -XX-
          -CX-
          -dEXTDEBUG
          -vh-
          -vn-
          -vw-
          -dDEBUG_NODE_XML


---

Lazarus is built with these options :
            -gw2
            -godwarfsets
            -godwarfmethodclassprefix
            -gl
            -O-
            -Si-
            -vb
            -vn-
            -vh-
            -vw-
            -dDBG_WITH_DEBUGGER_DEBUG
            -Cit
            -gt
            -gv


---

Backtrace from GDB:

munmap_chunk(): invalid pointer

Thread 1 "lazarus" received signal SIGABRT, Aborted.
0x00007ffff7452615 in raise () from /usr/lib/libc.so.6
(gdb) bt
#0  0x00007ffff7452615 in raise () at /usr/lib/libc.so.6
0000001  0x00007ffff743b862 in abort () at /usr/lib/libc.so.6
0000002  0x00007ffff74945e8 in __libc_message () at /usr/lib/libc.so.6
0000003  0x00007ffff749c27a in  () at /usr/lib/libc.so.6
0000004  0x00007ffff749c6ac in munmap_chunk () at /usr/lib/libc.so.6
0000005  0x00007ffff78f9515 in g_value_unset () at /usr/lib/libgobject-2.0.so.0
0000006  0x00007ffff78dc681 in  () at /usr/lib/libgobject-2.0.so.0
0000007  0x00007ffff78e3dac in g_object_setv () at /usr/lib/libgobject-2.0.so.0
0000008  0x00007ffff78e3e7c in g_object_set_property () at /usr/lib/libgobject-2.0.so.0
0000009  0x00000000008fb649 in LCLINTFCELLRENDERER_CELLDATAFUNC (CELL_LAYOUT=0x38b0800, CELL=0x3e471b0, TREE_MODEL=0x3c4b980, ITER=0x7fffffffdd50, DATA=0x39c4e58) at gtk2cellrenderer.pas:472
0000010 0x00007ffff7b58c0f in gtk_tree_view_column_cell_set_cell_data () at /usr/lib/libgtk-x11-2.0.so.0
0000011 0x00007ffff7b40cd4 in  () at /usr/lib/libgtk-x11-2.0.so.0
0000012 0x00007ffff7b434d7 in  () at /usr/lib/libgtk-x11-2.0.so.0
0000013 0x00007ffff7b43e97 in  () at /usr/lib/libgtk-x11-2.0.so.0
0000014 0x00007ffff7b43f49 in  () at /usr/lib/libgtk-x11-2.0.so.0
0000015 0x00007ffff7ee4257 in  () at /usr/lib/libgdk-x11-2.0.so.0
0000016 0x00007ffff77e3b00 in g_main_context_dispatch () at /usr/lib/libglib-2.0.so.0
0000017 0x00007ffff78351f9 in  () at /usr/lib/libglib-2.0.so.0
0000018 0x00007ffff77e2421 in g_main_context_iteration () at /usr/lib/libglib-2.0.so.0
0000019 0x0000000000530a32 in TGTK2WIDGETSET__APPPROCESSMESSAGES (this=0x20bd028) at gtk2widgetset.inc:2377
0000020 0x00000000004bc579 in TAPPLICATION__HANDLEMESSAGE (this=0x20babe8) at include/application.inc:1208
0000021 0x00000000004bcbe1 in TAPPLICATION__RUNLOOP (this=0x20babe8) at include/application.inc:1327
0000022 0x0000000000704a84 in TWIDGETSET__APPRUN (this=0x20bd028, ALOOP=...) at include/interfacebase.inc:54
0000023 0x00000000004bcb70 in TAPPLICATION__RUN (this=0x20babe8) at include/application.inc:1315
0000024 0x000000000041f461 in main () at lazarus.pp:153
Tagspatch
Fixed in Revisionr63902
LazTarget-
WidgetsetGTK 2
Attached Files

Activities

Cyrax

2020-09-20 18:11

reporter   ~0125676

Attached patch fixes this bug.
gtk2cellrenderer.pas.diff (403 bytes)   
diff --git a/lcl/interfaces/gtk2/gtk2cellrenderer.pas b/lcl/interfaces/gtk2/gtk2cellrenderer.pas
index b212405e7f..a39f9b88f6 100644
--- a/lcl/interfaces/gtk2/gtk2cellrenderer.pas
+++ b/lcl/interfaces/gtk2/gtk2cellrenderer.pas
@@ -425,6 +425,7 @@ var
   ListItem: TListItem;
   Value: TGValue;
 begin
+  FillByte(Value{%H-},SizeOf(Value),0);
   if G_IS_OBJECT(cell) = false then
     exit;
 
-- 
2.28.0
gtk2cellrenderer.pas.diff (403 bytes)   

Juha Manninen

2020-09-21 10:36

developer   ~0125700

Applied, thanks.

Issue History

Date Modified Username Field Change
2020-09-20 16:56 Cyrax New Issue
2020-09-20 18:11 Cyrax Note Added: 0125676
2020-09-20 18:11 Cyrax File Added: gtk2cellrenderer.pas.diff
2020-09-20 18:33 Cyrax Tag Attached: patch
2020-09-21 10:29 Juha Manninen Assigned To => Juha Manninen
2020-09-21 10:29 Juha Manninen Status new => assigned
2020-09-21 10:36 Juha Manninen Status assigned => resolved
2020-09-21 10:36 Juha Manninen Resolution open => fixed
2020-09-21 10:36 Juha Manninen Fixed in Revision => r63902
2020-09-21 10:36 Juha Manninen LazTarget => -
2020-09-21 10:36 Juha Manninen Widgetset GTK 2 => GTK 2
2020-09-21 10:36 Juha Manninen Note Added: 0125700
2020-09-24 17:49 Cyrax Status resolved => closed
2021-01-19 16:29 Juha Manninen Relationship added related to 0038347
2021-01-19 16:37 Juha Manninen Relationship deleted related to 0038347